#include <stdio.h>
#include <stdlib.h>

#include "Compiler.h"
#include "Script.h"
#include "Tokenizer.h"

int main() {
    if(tTokenize("../tests/test")) {
        puts(tGetError());
        return 0;
    }

    while(true) {
        Token token = tReadToken();
        if(token == T_END) {
            break;
        }
        if(token == T_INT) {
            int value;
            tReadInt(&value);
            printf("> %s %d\n", tGetTokenName(token), value);
        } else {
            printf("> %s\n", tGetTokenName(token));
        }
    }
    tResetReader();

    int codeLength = 0;
    unsigned char* code = cCompile(&codeLength);
    if(code == NULL) {
        if(cGetError() == NULL) {
            puts("error not set as it should");
        } else {
            puts(cGetError());
        }
        return 0;
    }

    Script* sc = sInit(code, codeLength);
    sRun(sc);
    sDelete(sc);
    return 0;
}